OGRE: Ogre::DefaultSphereSceneQuery Class Reference - OGRE Documentation

# Ogre::DefaultSphereSceneQuery Class Reference

Default implementation of SphereSceneQuery. More...

`#include <OgreSceneManager.h>`

Inheritance diagram for Ogre::DefaultSphereSceneQuery:

[legend]

List of all members.

## Public Types
enum | WorldFragmentType { WFT_NONE, WFT_PLANE_BOUNDED_REGION, WFT_SINGLE_INTERSECTION, WFT_CUSTOM_GEOMETRY, WFT_RENDER_OPERATION }
| This type can be used by collaborating applications & SceneManagers to agree on the type of world geometry to be returned from queries. More...
## Public Member Functions
| DefaultSphereSceneQuery (SceneManager *creator)
| ~DefaultSphereSceneQuery ()
void | execute (SceneQueryListener *listener)
| See SceneQuery.
void | setSphere (const Sphere &sphere)
| Sets the sphere which is to be used for this query.
const Sphere & | getSphere () const
| Gets the sphere which is being used for this query.
virtual SceneQueryResult & | execute (void)
| Executes the query, returning the results back in one list.
virtual SceneQueryResult & | getLastResults (void) const
| Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.
virtual void | clearResults (void)
| Clears the results of the last query execution.
bool | queryResult (MovableObject *first)
| Self-callback in order to deal with execute which returns collection.
bool | queryResult (SceneQuery::WorldFragment *fragment)
| Self-callback in order to deal with execute which returns collection.
virtual void | setQueryMask (uint32 mask)
| Sets the mask for results of this query.
virtual uint32 | getQueryMask (void) const
| Returns the current mask for this query.
virtual void | setQueryTypeMask (uint32 mask)
| Sets the type mask for results of this query.
virtual uint32 | getQueryTypeMask (void) const
| Returns the current mask for this query.
virtual void | setWorldFragmentType (enum WorldFragmentType wft)
| Tells the query what kind of world geometry to return from queries; often the full renderable geometry is not what is needed.
virtual WorldFragmentType | getWorldFragmentType (void) const
| Gets the current world fragment types to be returned from the query.
virtual const std::set < WorldFragmentType > * | getSupportedWorldFragmentTypes (void) const
| Returns the types of world fragments this query supports.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Attributes
Sphere | mSphere
SceneQueryResult * | mLastResult
SceneManager * | mParentSceneMgr
uint32 | mQueryMask
uint32 | mQueryTypeMask
std::set< WorldFragmentType > | mSupportedWorldFragments
WorldFragmentType | mWorldFragmentType

## Detailed Description

Default implementation of SphereSceneQuery.

Definition at line 3141 of file OgreSceneManager.h.

## Member Enumeration Documentation

enum Ogre::SceneQuery::WorldFragmentType`[inherited]`

This type can be used by collaborating applications & SceneManagers to agree on the type of world geometry to be returned from queries.

Not all these types will be supported by all SceneManagers; once the application has decided which SceneManager specialisation to use, it is expected that it will know which type of world geometry abstraction is available to it.

Enumerator:

  WFT_NONE | Return no world geometry hits at all.
  WFT_PLANE_BOUNDED_REGION | Return pointers to convex plane-bounded regions.
  WFT_SINGLE_INTERSECTION | Return a single intersection point (typically RaySceneQuery only).
  WFT_CUSTOM_GEOMETRY | Custom geometry as defined by the SceneManager.
  WFT_RENDER_OPERATION | General RenderOperation structure.

Definition at line 77 of file OgreSceneQuery.h.

## Constructor & Destructor Documentation

Ogre::DefaultSphereSceneQuery::DefaultSphereSceneQuery | ( | SceneManager * | creator | ) |

Ogre::DefaultSphereSceneQuery::~DefaultSphereSceneQuery | ( |  | ) |

## Member Function Documentation

void Ogre::DefaultSphereSceneQuery::execute | ( | SceneQueryListener * | listener | ) | `[virtual]`

See SceneQuery.

Implements Ogre::RegionSceneQuery.

void Ogre::SphereSceneQuery::setSphere | ( | const Sphere & | sphere | ) | `[inherited]`

Sets the sphere which is to be used for this query.

const Sphere& Ogre::SphereSceneQuery::getSphere | ( |  | ) | const`[inherited]`

Gets the sphere which is being used for this query.

virtual SceneQueryResult& Ogre::RegionSceneQuery::execute | ( | void |  | ) | `[virtual, inherited]`

Executes the query, returning the results back in one list.

Remarks:
  This method executes the scene query as configured, gathers the results into one structure and returns a reference to that structure. These results will also persist in this query object until the next query is executed, or clearResults() is called. An more lightweight version of this method that returns results through a listener is also available.

virtual SceneQueryResult& Ogre::RegionSceneQuery::getLastResults | ( | void |  | ) | const`[virtual, inherited]`

Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.

virtual void Ogre::RegionSceneQuery::clearResults | ( | void |  | ) | `[virtual, inherited]`

Clears the results of the last query execution.

Remarks:
  You only need to call this if you specifically want to free up the memory used by this object to hold the last query results. This object clears the results itself when executing and when destroying itself.

bool Ogre::RegionSceneQuery::queryResult | ( | MovableObject * | first | ) | `[virtual, inherited]`

Self-callback in order to deal with execute which returns collection.

Implements Ogre::SceneQueryListener.

bool Ogre::RegionSceneQuery::queryResult | ( | SceneQuery::WorldFragment * | fragment | ) | `[virtual, inherited]`

Self-callback in order to deal with execute which returns collection.

Implements Ogre::SceneQueryListener.

virtual void Ogre::SceneQuery::setQueryMask | ( | uint32 | mask | ) | `[virtual, inherited]`

Sets the mask for results of this query.

Remarks:
  This method allows you to set a 'mask' to limit the results of this query to certain types of result. The actual meaning of this value is up to the application; basically MovableObject instances will only be returned from this query if a bitwise AND operation between this mask value and the MovableObject::getQueryFlags value is non-zero. The application will have to decide what each of the bits means.

virtual uint32 Ogre::SceneQuery::getQueryMask | ( | void |  | ) | const`[virtual, inherited]`

Returns the current mask for this query.

virtual void Ogre::SceneQuery::setQueryTypeMask | ( | uint32 | mask | ) | `[virtual, inherited]`

Sets the type mask for results of this query.

Remarks:
  This method allows you to set a 'type mask' to limit the results of this query to certain types of objects. Whilst setQueryMask deals with flags set per instance of object, this method deals with setting a mask on flags set per type of object. Both may exclude an object from query results.

virtual uint32 Ogre::SceneQuery::getQueryTypeMask | ( | void |  | ) | const`[virtual, inherited]`

Returns the current mask for this query.

virtual void Ogre::SceneQuery::setWorldFragmentType | ( | enum WorldFragmentType | wft | ) | `[virtual, inherited]`

Tells the query what kind of world geometry to return from queries; often the full renderable geometry is not what is needed.

Remarks:
  The application receiving the world geometry is expected to know what to do with it; inevitably this means that the application must have knowledge of at least some of the structures used by the custom SceneManager.

  The default setting is WFT_NONE.

virtual WorldFragmentType Ogre::SceneQuery::getWorldFragmentType | ( | void |  | ) | const`[virtual, inherited]`

Gets the current world fragment types to be returned from the query.

virtual const std::set<WorldFragmentType>* Ogre::SceneQuery::getSupportedWorldFragmentTypes | ( | void |  | ) | const`[virtual, inherited]`

Returns the types of world fragments this query supports.

Definition at line 169 of file OgreSceneQuery.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

## Member Data Documentation

Sphere Ogre::SphereSceneQuery::mSphere`[protected, inherited]`

Definition at line 284 of file OgreSceneQuery.h.

SceneQueryResult* Ogre::RegionSceneQuery::mLastResult`[protected, inherited]`

Definition at line 221 of file OgreSceneQuery.h.

SceneManager* Ogre::SceneQuery::mParentSceneMgr`[protected, inherited]`

Definition at line 117 of file OgreSceneQuery.h.

uint32 Ogre::SceneQuery::mQueryMask`[protected, inherited]`

Definition at line 118 of file OgreSceneQuery.h.

uint32 Ogre::SceneQuery::mQueryTypeMask`[protected, inherited]`

Definition at line 119 of file OgreSceneQuery.h.

std::set<WorldFragmentType> Ogre::SceneQuery::mSupportedWorldFragments`[protected, inherited]`

Definition at line 120 of file OgreSceneQuery.h.

WorldFragmentType Ogre::SceneQuery::mWorldFragmentType`[protected, inherited]`

Definition at line 121 of file OgreSceneQuery.h.

The documentation for this class was generated from the following file:

- OgreSceneManager.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:36:12 2009